#include "vs1103.h"

#define GPIO_IDATA GPIO_DATA
#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   8
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */

	.sect code,SpiSendClocks
	.export _SpiSendClocks
_SpiSendClocks:
#if 0
// auto void SpiSendClocks(void);
	stx ls,(i6)+1	; sty le,(i6)

	ldc 1,i5
	ldc SER_DREQ,i7
	stx i5,(i7)+(GPIO_ODATA-SER_DREQ) ; sty lc,(i6)	// data out (=1)
	ldc 16-1,ls
	loop ls,$0-1
	nop

	nop
	j $10	// 3 cycles
$10:	ldc SPI_CLK|SPI_xCS|SPI_xCS2,i5
	stx i5,(i7)	// clk up

	nop
	j $11	// 3 cycles
$11:	ldc SPI_xCS|SPI_xCS2,i5
	stx i5,(i7)	// clk down
	//nop	//VS1003 seems to require this
$0:
	ldy (i6)-1,lc
	jr
	ldx (i6)-1,ls	; ldy (i6),le
	//Normally loop hw can not be restored in JR delay slot,
	//but we know that SpiSendClocks is not called from HW loop
#else
	stx a0,(i6)+1	; sty a1,(i6)
	or a0,ones,a0	; stx lr0,(i6)+1
	ldc 16,a1
	stx d0,(i6)+1	; sty c0,(i6)
	ldc SPI_CLK|SPI_xCS|SPI_xCS2,c0
	call _SpiCommon
	ldc SPI_xCS|SPI_xCS2,d0

	ldx (i6)-1,lr0
	jr
	ldx (i6)-1,a0	; ldy (i6),a1
#endif


	.sect code,SpiSendReceiveMmc
	.export _SpiSendReceiveMmc16
	.export _SpiSendReceiveMmc
_SpiSendReceiveMmc16:
	ldc 16,A1
_SpiSendReceiveMmc:
// auto u_int16 SpiSendReceiveMmc(register __a0 u_int16 dataTopAligned, register __a1 bits);
	// A0 = 16-bit data to send, A0 = data read
	// I7, A1, D1 tmp regs
	stx d0,(i6)+1	; sty c0,(i6)
	ldc SPI_CLK|SPI_xCS,c0	//MMC CLK up, SPI CS up, MMC CS down
	ldc SPI_xCS,d0		//MMC CLK down, SPI CS up, MMC CS down
	.export _SpiCommon
_SpiCommon:
	stx lc,(i6)+1	; sty c1,(i6)
	add a1,ones,c1	; stx ls,(i6)
	lsl a,a		; sty le,(i6)	//shift the first output bit to a1
	ldc SER_DREQ,i7

	loop c1,$0-1
	ldc SPI_MISO_SHIFT,c1
$1:
//
//This should also work on cards that work on the wrong edge
//
//Capacitance on SDCK helps a problem card??? (1000pF = 1nF is ok)
//
#if 1 //should work with cards that work on the wrong edge
	stx a1,(i7)+(GPIO_IDATA-SER_DREQ)	//data out -> DREQ
	nop
	nop // as much delay between clk down and data i/o as possible
	//At least TWO NOP's ARE NEEDED!
	ldx (i7)+(GPIO_ODATA-GPIO_IDATA),a1	//data in, note pipeline!
	stx c0,(i7)+(GPIO_ODATA-GPIO_ODATA) // clk up   ODATA
	ashl a1,c1,a1			    // shift data to Carry
	nop
	nop	//shift data in from Carry, and next bit to send to a1
	//nop//extra
	lslc a,a	; stx d0,(i7)+(SER_DREQ-GPIO_ODATA)	// clk down
	//nop//extra
#else
//from vs1063 standalone player - 
	nop
	nop // as much delay between clk down and data i/o as possible
	stx a1,(i7)+(GPIO_IDATA-SER_DREQ)	//data out
	ldx (i7)+(GPIO_ODATA-GPIO_IDATA),a1	//data in, note pipeline!
	stx c0,(i7)+(GPIO_ODATA-GPIO_ODATA) // clk up   ODATA
	ashl a1,c1,a1
	nop
	nop
	lslc a,a	; stx d0,(i7)+(SER_DREQ-GPIO_ODATA)	// clk down
#endif
$0:
	ldx (i6)-1,ls	; ldy (i6),le
	ldx (i6)-1,lc	; ldy (i6),c1
	jr
	ldx (i6)-1,d0	; ldy (i6),c0

// DO DI Clkup Clkdwn

	.end
