/*
X:	_streamBuffer 0x0..0x1ff
	_rxRtMidi 0x200..203
	_imabss 0x20d..0x20f
	_rxBuf 0x210..0x21f
	bassOn,trebleOn,streamMode,..	0x222..
	pcm_sample,pcm_point 0x232..
	generalbss applAddr 0x273..
	ai, outBuf 0x27f...
	bassCompandMaxGain 0x2c1
	_wav,.. 0x2c2..
	_er 0x2eb..

	mixerbufs 0x300..
	_codecMidi 0x400..0x17ff
	_userArea 0x1800..0x187f
	_stack 0x1880..0x19ff
	_parametric_x 0x1a00..0x1a3f
	_mixer.. 0x1a40..

y:	audioBuffer 0x0..0x7ff
	reverbDelays 0x800..0x13ff
	sci_buffer/imaOutBuf 0x1400..17ff
	_userArea 0x1800..0x187f
	_stack 0x1880..0x19ff
	 modbuf 0x1a00..0x1a3f
	 trebleFilt 0x1a40..
	 bss_y 0x1a52..

*/

#include "vs1103.h"
#include <module.h>

	.sect code,reset
	.export _main
_main:
	ldc _MyModuInt-1,i0
	ldc 0x23,i1	// MODU 0x23
	ldi (i0)+1,a
	sti a,(i1)
	nop
	.import _MyMain
	j _MyMain
	ldc 1,a1	// perform full init
	.export _MyReset
_MyReset:
	j _MyMain
	ldc 0,a1	// perform partial init


	.sect code,MyModuInt
	.export _MyModuInt
	.import _moduOffset
	jmpi _MyModuInt,(i6)+1
_MyModuInt:
	// 29+2 cycles
	sty i7,(i6)+1
	stx I3,(I6)+1	; sty I2,(I6)
	stx D0,(I6)+1	; sty I1,(i6)
	stx A2,(I6)+1	; sty I4,(i6)
	stx A0,(I6)+1	; sty A1,(i6)
	add null,p,a	; stx MR0,(I6)+1 // Must be before add null,p,a !!:-)
	stx A0,(I6)	; sty A1,(i6)

	ldc MR_SAT|MR_INT,mr0
	.import _adcWrPointer
	ldc _adcWrPointer,I7
	ldc 0x8000+ADC_BUF_SIZE-1,i2
	ldc MODU_DATA,I1
	ldc _moduOffset+1,i4

	// out = in - (moduOffset>>16);
	// moduOffset += out;
	ldx (I7),I3
	ldx (i1),d0	; ldy (i4)-1,a1
	ldc 4096,a0			// Increase speed: multiply with X
	sub d0,a1,d0
	mulss a0,d0	; ldy (i4),a0
	add a,p,a	; stx d0,(i3)*
	stx i3,(i7)	; sty a0,(i4)+1
	asr d0,d0	; sty a1,(i4)
#if 1
	ldc DAC_LEFT,i4
	stx d0,(i4)+1
	stx d0,(i4)
#endif

	ldx (I6)-1,A0	; ldy (I6),A1
	resp a0,a1
	ldx (I6)-1,MR0
	ldx (I6)-1,A0	; ldy (I6),A1
	ldx (I6)-1,A2	; ldy (I6),I4
	ldx (I6)-1,D0	; ldy (I6),I1
	ldx (i6)-1,I3	; ldy (I6),I2

	ldc INT_GLOB_ENA,i7
	reti
	stx i7,(i7)	; ldy (i6)-1,i7





	.end
