//#include <module.h>
#include <hardware.h>

	// The intent of this dummy variable is to take care that
	// the fourth byte in the image created with this startup is NOT 0.
	// This in turn will make code distinguishable from an IMA ADPCM
	// block.
	.sect data_x,dummy_data_x
	.export _dummyVariable
_dummyVariable:
	// Identification string: 0x5B + version number, image offset 8:9
	.word 0x5b03
	// MIDI playback volume, image offset 10:11
	.word 23
	// ADPCM playback volume, image offset 12:13
	.word 31
	// MIDI Transpose address, image offset 14:15
	.word 12
	// Record sample rate divider (from 48000), image offset 16:17
	.word 3


	// Actual code

	.sect code,reset
	.org 0x30

	.import _rommain
	.import _exit
	.import _MyMain

	.import __stack
	ldc __stack,i6

	// Set certain parameters
	call _MyMain
	ldx (i6)+1,null

	// Activate my own hook
	ldc myHooks,i7

	ldc 0,i0
	ldi (i7)+1,a
	sti a,(i0)
	nop
	nop

	// Start ROM main
	j _rommain
	ldc _exit,lr0




	.import _MyUserHook
myHooks:
	j _MyUserHook







#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   2
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
/*#define SPI_xCS2  8*/
#define GPIO_BUT  8
#define SPI_MOSI  1 /* DREQ */

	.sect code,SpiSendReceiveMmc
	.export _SpiSendReceiveMmc16
	.export _SpiSendReceiveMmc
_SpiSendReceiveMmc16:
	ldc 16,A1
_SpiSendReceiveMmc:
// auto u_int16 SpiSendReceiveMmc(register __a0 u_int16 dataTopAligned, register __a1 bits);
	// A0 = 16-bit data to send, A0 = data read
	// I7, A1, D1 tmp regs
	stx d0,(i6)+1	; sty c0,(i6)
	stx lc,(i6)+1	; sty c1,(i6)

	ldc 16,c0
	sub c0,a1,c0
	ashl a0,c0,a0

	ldc SPI_CLK/*|SPI_xCS*/,c0
	ldc 0/*|SPI_xCS*/,d0
	
	add a1,ones,c1	; stx ls,(i6)
	lsl a,a		; sty le,(i6)
	ldc SER_DREQ,i7

	loop c1,$0-1
	ldc SPI_MISO_SHIFT,c1
$1:
	// PLL2_0  66/33% clock 4.1 MHz
	//=2.0*12.288/6 = 4.096
	// 2.0*12.288/7 = 3.511

	// PLL3_5  55/45% clock 4.8 MHz
	// 3.5*12.288/7 = 6.144
	// 3.5*12.288/8 = 5.376
	//=3.5*12.288/9 = 4.779
	// 3.5*12.288/10 = 4.3008

#ifdef PLL3_5
	nop
	nop // as much delay between clk down and data i/o as possible
	stx a1,(i7)+(GPIO_DATA-SER_DREQ)	//data out
#else
	nop // as much delay between clk down and data i/o as possible
	stx a1,(i7)+(GPIO_DATA-SER_DREQ)	//data out
#endif
	ldx (i7)+(GPIO_ODATA-GPIO_DATA),a1	//data in, note pipeline!
	stx c0,(i7)+(GPIO_ODATA-GPIO_ODATA) // clk up   ODATA
	ashl a1,c1,a1
#ifdef PLL3_5
	nop
	nop
#endif
	lslc a,a	; stx d0,(i7)+(SER_DREQ-GPIO_ODATA)	// clk down
$0:
	ldx (i6)-1,ls	; ldy (i6),le
	ldx (i6)-1,lc	; ldy (i6),c1
	jr
	ldx (i6)-1,d0	; ldy (i6),c0


	.end
