#define STANDALONE
#define USE_EARSPEAKER
#include <string.h>
#include "module.h"
#include "vs1103.h"
#ifdef UART_FIFO
#include "uartctrl.h"
#endif

auto void PatchInitHardware(void);

//void SetSourcesFromSpi(void);
//auto void SetDreqSafetyAreaFromSpi(void);

void putch(register __a0 int ch);
void putch15(register __a0 int ch);
void putword(register __a0 int ch);
void Monitor(void); /*never returns*/

void putstrp(register __i2 const u_int16 *s) {
    while (1) {
	if (!(*s & 0xff00))
	    break;
	putch15(*s);
	if (!(*s & 0xff))
	    break;
	putch(*s++);
    }
}

auto void play_frame(void);
//void Disable();
//void Enable();
//void Reset();

//#undef putchar
//#undef puts

//#include <stdio.h>

#include <stdlib.h>

#ifdef WAIT_FOR_UART_BYTE
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC))
#else
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#endif/*elseWAIT_FOR_UART_BYTE*/


#define KEEP_DRIVERS_OFF /* .. until MMC located */
#define WITH_SUBDIRECTORIES /* support subdirectories */

#define CTRL3_UPDATE_VOL        (1<<15)
#define CTRL3_I2S_ENABLE        (1<<9) /*VS1053: enable I2S*/
#define CTRL3_BY_NAME           (1<<8) /*locate by name*/
#define CTRL3_RECORD_ON         (1<<7)
#define CTRL3_AT_END            (1<<6)
#define CTRL3_NO_NUMFILES       (1<<5)
#define CTRL3_PAUSE_ON          (1<<4)
#define CTRL3_FILE_READY        (1<<3)

#define CTRL3_PLAY_MODE_MASK    (3<<1)
#define CTRL3_PAUSE_AFTER_PLAY  (3<<1)
#define CTRL3_PAUSE_BEFORE_PLAY (2<<1)
#define CTRL3_LOOP_SONG         (1<<1)
#define CTRL3_PLAY_NEXT         (0<<1)

#define CTRL3_RANDOM_PLAY       (1<<0) /* SCI_AICTRL3 */

#ifndef GPIO_IDATA
#define GPIO_IDATA GPIO_DATA
#endif

#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   8 /*MMC clk*/
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */

//#define SPI_WREN  0x06
//#define SPI_WRDI  0x04
//#define SPI_RDSR  0x05
//#define SPI_WRSR  0x01
#define SPI_READ  0x03
//#define SPI_WRITE 0x02

typedef enum {
    spi_pause=0,
    spi_file,
    spi_seek,
    spi_waitdata,
    spi_data,
    spi_zeros,
    spi_record,
    spi_waitima
} SPISTATE;

SPISTATE spiState, oldSpiState;
s_int16 spiCnt;

#include "spifs.h"
auto void ReadDiskSector(register __a u_int32 sector) {
    register s_int16 i;
    register u_int16 *buffer = stream_buffer;

    sector += SPIFSSTARTBLOCK; /* convert logical to physical */
#if 0
    puthex(sector>>16);
    puthex(sector);
    putch(' ');
    putch('s');
    putch('e');
    putch('c');
    putch('\n');
#endif

    USEX(GPIO_ODATA) |= SPI_xCS;
    USEX(GPIO_DDR)   |= SPI_xCS;
    USEX(GPIO_ODATA) &= ~SPI_xCS;
    SpiSendReceiveSpi((SPI_READ<<8), 8);
    SpiSendReceiveSpi(sector<<1, 16);
    SpiSendReceiveSpi(0, 8);
    for (i=0;i<512/2;i++) {
	*buffer++ = SpiSendReceiveSpi(0, 16);
#if 0
  puthex(buffer[-1]);
  if ((i & 7) == 7)
    putch('\n');
#endif
    }
    USEX(GPIO_ODATA) |= SPI_xCS;
    return;
}

auto u_int16 GetByte(register __c0 u_int16 n);
auto u_int16 GetWord(register __c0 u_int16 n);
auto u_int32 GetLong(register __c0 u_int16 n);

extern __y u_int16 fileName[6];

u_int16 gFileNum[2];
u_int32 fileSize, fileStart;
u_int32 spiSize;
u_int32 spiAddr;

auto s_int16 OpenFile(register __c0 u_int16 fileNum) {
    register __c1 int i = 12;
    u_int32 currentSector;
    __y u_int32 dataStart;

    gFileNum[0] = fileNum;
    gFileNum[1] = 0;

#ifdef ENABLE_WATCHDOG
    USEX(WDOG_RESET) = WDOG_RESET_VAL;
#endif
    /* see spifs.h - ident, numHeaderBlocks, reserved, max 25 file entries*/
    ReadDiskSector(currentSector = 0);
    dataStart = GetLong(4); /* number of header blocks */
    while (1) {
	register __d1 u_int16 fn = GetByte(i+0); /* first char of filename */

	/* We are now looking at a directory entry. */
	/* Is current file a regular file? */
	if (fn == 0 || fn == 0xff) {
	    goto eod; /*end of directory*/
	}
#if defined(SCI_UI)
	if (USEX(SCI_AICTRL3) & CTRL3_BY_NAME) {
	    register int j, t = 0;
	    register u_int16 *p = stream_buffer + i/2;
	    register __y u_int16 *d = fileName;
	    p[5] &= 0xff00; /* clear the attribute byte */
	    for (j=0; j<6; j++) {
		t |= *d++ ^ *p++;
	    }
	    if (t == 0) {
		USEX(SCI_AICTRL0) = gFileNum[1];
		goto thisfile;
	    }
	}
#endif

	gFileNum[1]++;
	if (gFileNum[0]-- == 0) {
	thisfile:
#ifdef SCI_UI
	    /* Put the 8.3-character filename to memory so the user
	       can read it. Two bytes per word, big-endian. */
	    {   /* 13 words */
		register int j;
		register u_int16 *p = stream_buffer + i/2;
		register __y u_int16 *d = fileName;
		for (j=0;j<6;j++) {
		    *d++ = *p++;
		}
	    }
#endif
	    /* ------------ FILE FOUND ------------- */
	    fileSize = GetLong(i+16);
	    fileStart = dataStart + GetLong(i+12) + SPIFSSTARTBLOCK;
#if 0
	    puthex(fileSize);
	    putch('s');
	    putch('z');
	    putch('\n');
#endif
	    return -1; /* File found, All OK return */
	}
	i = (i + 20); /* 20 bytes per entry */
	if (i >= 512) {
	    currentSector++;
	    i = 12;
	    if (currentSector >= dataStart) {
	eod:
#if 0
	    putch('e');
	    putch('o');
	    putch('d');
	    putch('\n');
#endif
#if defined(SCI_UI)
		USEX(SCI_AICTRL3) &= ~CTRL3_BY_NAME;
#endif
		return gFileNum[1];
	    }
	    ReadDiskSector(currentSector);
	}
    }
}

/*
  Called before HALT
 */
void UserHook(void) {
}

void GetFlashSize(void) {
/* RDID: Command / manufacturer ID / memory type / memory density */
  /* Determine size from the RDID sequence */
  u_int16 mf = 0, status = 0;

  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi((0x9f<<8),8);
  mf = SpiSendReceiveSpi(0,8);
  status = SpiSendReceiveSpi(0,16);
  USEX(GPIO_ODATA) |= SPI_xCS;
  putch(mf);
  putword(status);
#if 0 //def UART_FIFO
  if (mf == 0xc2) { /*Macronix*/
    putstrp("\pMacronix\n");
    } else if (mf == 0xef) { /*Winbond*/
    putstrp("\pWinbond\n");
  } else {
    putstrp("\pUnknown manufacturer\n");
  }
#endif
#if 0
  if ((status & 0xff) == 21) {
    putstrp("\p2MB\n");
  } else if ((status & 0xff) == 24) {
    putstrp("\p16MB\n");
  }
#endif
  if ((status & 0xff)) {
    common.blocks = (1L << ((status & 0xff)-9));
  } else {
    /* undefined size */
    common.blocks = 0;
  }
}


auto void MyMain(register s_int16 __a1 fullReset) {
#ifdef BATTCHECK
    USEX(MODU_DIV) = 0x0030;
#endif/*BATTCHECK*/

#if defined(SCI_UI) && defined(ENABLE_WATCHDOG)
    USEX(WDOG_CONFIG) = 1000;
    USEX(WDOG_RESET) = WDOG_RESET_VAL;
#endif

#if defined(SCI_UI)
    USEX(SCI_AICTRL2) = 0;
#endif
#if 0 && defined(VS1103)
    USEX(SCI_MODE) = (1<<SCIMB_SDI_NEWMODE)
	+ (0<<SCIMB_CONF); /*0=SDIMIDI,SCIWAV 1=SDIWAV,SCIMIDI*/
#endif

    USEX(SCI_MODE) &= ~(1<<SCIMB_OUT_OF_WAV);
#if 0 //For vs1103 greeting card player
    USEX(SCI_MODE) |= (1<<SCIMB_DIFFERENTIAL);
#endif

#ifdef USE_BUTTON
    USEX(GPIO_DDR)   = SPI_xCS|SPI_xCS2;
    USEX(GPIO_ODATA) = SPI_xCS|SPI_xCS2;
#else
    USEX(GPIO_DDR)   = SPI_xCS|SPI_CLK|SPI_xCS2;
    USEX(GPIO_ODATA) = SPI_xCS|SPI_xCS2;
#endif

#if 1
    /* 'wake up' spi memory */
    USEX(GPIO_ODATA) &= ~SPI_xCS;
    SpiSendReceiveSpi((SPI_READ<<8), 8);
    SpiSendReceiveSpi(0<<1, 16);
    SpiSendReceiveSpi(0, 8);
    USEX(GPIO_ODATA) |= SPI_xCS;
#endif

    if (!(USEX(SCI_STATUS) & (1<<SCIST_APDOWN2))) {
      putstrp("\prebooted\n\n");
      /* already booted once before */
      USEX(SCI_VOL) = common.volume;
    } else {
      uartByteSpeed = 115200/10;
      PatchInitHardware(); /* does not clear user area */
      memset(&common, 0, sizeof(common));
      common.uiLoops = -1;
      common.volume = USEX(SCI_VOL);

      //putstrp("\pfirst boot\n\n");
#if 1 /*VERSION*/
	/*
	  v0.6 print version string
	*/
	putword(('R'<<8)|'E');
	putword(('0'<<8)|'.');
	putword(('6'<<8)|'0');
	putch('\n');
#endif

      GetFlashSize(); /* determine FLASH size */
    }
    /* TODO: move UART_FIFO to a fixed address,
             so we can also setup it just once.
	     Also needs the interrupt handler in a
	     fixed address.
    */
#ifdef UART_FIFO
    UartInit();
#endif

    //AudioInit(); //rather use..
    //AudioSet(2, 44100U);

    /* Allow DREQ and enable interrupts, VERY IMPORTANT! */
    USEX(INT_ENABLE) = 0;
    USEX(INT_GLOB_ENA) = 0;

    InitCommon();
    InitReadFrame();
    AudioSet(2, 44100U);

    /* determine number of playable files */
    common.files = OpenFile(0xffffU);
#if defined(UART_UI) || defined(UART_FIFO)
    putstrp("\pfiles");
    putword(common.files);
    putch('\n');
#endif
    Disable();
    USEX(GPIO_ODATA) |= SPI_xCS;
    SpiLoad2(MODPLAYER_ADDR+3, 1);
}
