#ifdef SCI_UI
//#define USE_BUTTON /* Wait for button press (in GPIO3) to play a file. */
//#define PAUSE_AT_POWERON /*switches pause-before-play to pause-after-play*/
#endif

#define STANDALONE
#define USE_EARSPEAKER
#include <string.h>
#include "module.h"
#include "vs1103.h"
#include "asmfuncs.h"
#ifdef UART_FIFO
#include "uartctrl.h"
#endif


//#undef putchar
//#undef puts

//#include <stdio.h>

#include <stdlib.h>

#ifdef WAIT_FOR_UART_BYTE
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC))
#else
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#endif/*elseWAIT_FOR_UART_BYTE*/


#define KEEP_DRIVERS_OFF /* .. until MMC located */
#define WITH_SUBDIRECTORIES /* support subdirectories */

#define CTRL3_UPDATE_VOL        (1<<15)
#define CTRL3_I2S_ENABLE        (1<<9) /*VS1053: enable I2S*/
#define CTRL3_BY_NAME           (1<<8) /*locate by name*/
#define CTRL3_RECORD_ON         (1<<7)
#define CTRL3_AT_END            (1<<6)
#define CTRL3_NO_NUMFILES       (1<<5)
#define CTRL3_PAUSE_ON          (1<<4)
#define CTRL3_FILE_READY        (1<<3)

#define CTRL3_PLAY_MODE_MASK    (3<<1)
#define CTRL3_PAUSE_AFTER_PLAY  (3<<1)
#define CTRL3_PAUSE_BEFORE_PLAY (2<<1)
#define CTRL3_LOOP_SONG         (1<<1)
#define CTRL3_PLAY_NEXT         (0<<1)

#define CTRL3_RANDOM_PLAY       (1<<0) /* SCI_AICTRL3 */

#ifndef GPIO_IDATA
#define GPIO_IDATA GPIO_DATA
#endif

#define SPI_xCS   1 /* GPIO */
//#define SPI_CLK   8 /*MMC clk*/
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
//#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */

//#define SPI_WREN  0x06
//#define SPI_WRDI  0x04
//#define SPI_RDSR  0x05
//#define SPI_WRSR  0x01
#define SPI_READ  0x03
//#define SPI_WRITE 0x02

typedef enum {
    spi_pause=0,
    spi_file,
    spi_seek,
    spi_waitdata,
    spi_data,
    spi_zeros,
    spi_record,
    spi_waitima
} SPISTATE;

SPISTATE spiState, oldSpiState;
s_int16 spiCnt;

#include "spifs.h"
#define SPI_EEPROM_COMMAND_WRITE_ENABLE  0x06
#define SPI_EEPROM_COMMAND_WRITE_DISABLE  0x04
#define SPI_EEPROM_COMMAND_READ_STATUS_REGISTER  0x05
#define SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER  0x01
#define SPI_EEPROM_COMMAND_READ  0x03
#define SPI_EEPROM_COMMAND_WRITE 0x02
#define SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS 0x30
#define SPI_EEPROM_COMMAND_ERASE_4K_SECTOR 0x20
#define SPI_EEPROM_COMMAND_ERASE_CHIP 0xC7

s_int16 SpiGetStatus(void) {
	__mem_y s_int16 t;
	USEX(GPIO_ODATA) &= ~SPI_xCS;
	SpiSendReceiveSpi((SPI_EEPROM_COMMAND_READ_STATUS_REGISTER<<8), 8);
	t = SpiSendReceiveSpi(0, 8);
	USEX(GPIO_ODATA) |= SPI_xCS;
	return t;
}
void SingleCycleCommand(u_int16 cmd){
	USEX(GPIO_ODATA) &= ~SPI_xCS;
	SpiSendReceiveSpi((cmd<<8),8);
	USEX(GPIO_ODATA) |= SPI_xCS;
}
u_int16 SpiWaitStatus(void) {
	u_int16 status;
	while ((status = SpiGetStatus()) & 1)
		;
	return status;
}

void EeUnprotect(){
	SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
	USEX(GPIO_ODATA) &= ~SPI_xCS;
	SpiSendReceiveSpi(SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER<<8,8);
	SpiSendReceiveSpi(0x02<<8,8); //Sector Protections Off
	USEX(GPIO_ODATA) |= SPI_xCS;
	SpiWaitStatus();
	SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
}


auto void ReadDiskSector(register __a u_int32 sector) {
	register s_int16 i;
	register u_int16 *buffer = stream_buffer;

	USEX(GPIO_ODATA) |= SPI_xCS;
	USEX(GPIO_DDR)   |= SPI_xCS;
	USEX(GPIO_ODATA) &= ~SPI_xCS;
	SpiSendReceiveSpi((SPI_READ<<8), 8);
	/* convert logical to physical */
	SpiSendReceiveSpi((sector+SPIFSSTARTBLOCK)<<1, 16);
	SpiSendReceiveSpi(0, 8);
	for (i=0;i<512/2;i++) {
		*buffer++ = SpiSendReceiveSpi(0, 16);
	}
	USEX(GPIO_ODATA) |= SPI_xCS;
}

auto u_int16 GetByte(register __c0 u_int16 n);
auto u_int16 GetWord(register __c0 u_int16 n);
auto u_int32 GetLong(register __c0 u_int16 n);

__mem_y u_int16 fileName[6];

u_int32 fileSize = 0, fileStart = 0;
u_int16 fileEntry = 0, dirBlock = 0;
u_int32 spiSize;
u_int32 spiPage; /* Address counted in 256-byte write pages. */


/* Return first free data block and index to the free file entry.
 */
__mem_y u_int32 dataStart, freeStart = 0;
u_int32 FindEntry(u_int16 *dirline, u_int16 *dirblock) {
	register __c1 int i = 12;
	u_int32 currentSector;

	#ifdef ENABLE_WATCHDOG
	USEX(WDOG_RESET) = WDOG_RESET_VAL;
	#endif
	/* see spifs.h - ident, numHeaderBlocks, reserved, max 25 file entries*/
	ReadDiskSector(currentSector = 0);
	dataStart = GetLong(4); /* number of header blocks */
	if (dataStart == 0xffffffffUL) {
	  /* Uninitialized disk */
	  dataStart = 8;
	}
	freeStart = 0;
	while (1) {
		register __d1 u_int16 fn = GetByte(i+0); /* first char of filename */
	
		/* We are now looking at a directory entry. */
		/* Is current file a regular file? */
		if (fn == 0 || fn == 0xff) {
			if (dirblock) {
				*dirblock = (u_int16)currentSector;
			}
			if (dirline) {
				*dirline = i;
			}
			goto eod; /*end of directory*/
		}
		/* FILE entry - the space for next file starts immediately after
		this file. */
		memcpyXY(fileName, stream_buffer+i/2, 6);
		freeStart = GetLong(i+12) + (GetLong(i+16)+511)/512;
		/* Align to 4kB to allow overwrites. */
		freeStart = (freeStart + 7) & ~7L;
		i = (i + 20); /* 20 bytes per entry */
		if (i >= 512) {
			currentSector++;
			i = 12;
			if (currentSector >= dataStart) {
				eod:
				return freeStart + dataStart + SPIFSSTARTBLOCK;
			}
			ReadDiskSector(currentSector);
		}
	}
}
/*
  Insert the file entry. Only writes the relevant 20 bytes.
 */
void MakeEntry(u_int32 bytes, u_int16 dirLine, u_int16 dirBlock) {
	register u_int16 *p = stream_buffer + dirLine/2;
	u_int32 addr = (u_int32)(dirBlock+SPIFSSTARTBLOCK)*512 + dirLine;

	ReadDiskSector(dirBlock); /* contains + SPIFSSTARTBLOCK */

	memcpyYX(p, fileName, 6);
	if (*p != (('R'<<8) | 'E')) {
		memcpy(p, "\pRECORD00   ", 6);
	}
	p += 3;
	if ((*p & 0xff) >= '9') {
		*p += 0x100-9;
	} else {	
		*p = *p + 1;
	}
	p += 3;
	*p++ = Swap16(freeStart);
	*p++ = Swap16(freeStart>>16);
	*p++ = Swap16(bytes);
	*p++ = Swap16(bytes>>16);
	
	EeUnprotect();
	USEX(GPIO_ODATA) &= ~SPI_xCS;
	SpiSendReceiveSpi(SPI_EEPROM_COMMAND_WRITE<<8,16);
	SpiSendReceiveSpi(addr,16);
	p = stream_buffer+dirLine/2;
	{
		register u_int16 n;
		for (n=0; n<20/2; n++){ /* 20 bytes per entry */
			SpiSendReceiveSpi(*p++,16);
		}
	}
	USEX(GPIO_ODATA) |= SPI_xCS;
  	
	SpiWaitStatus();
	common.files++;
}


extern __y u_int16 hwSampleRate;
u_int16 __x * __x stream_save;

#if defined(USE_BUTTON)
__mem_y struct {
    u_int16 Data; /* must be first entry! Used by c.s */
    u_int16 Cnt;
    u_int16 Strobe;
    u_int16 Timer; /* Data,Cnt,Strobe,Timer must be in this order (buts.s) */
    u_int16 Key;
    s_int16 KeyTime;
#ifdef KEYTIMER
    s_int16 KeyTimer;
#endif
} ui;
#endif

#if 1

#if defined(USE_BUTTON)
s_int16 ApplAddr(register __i0 s_int16 **d, register __a1 s_int16 mode,
		 register __a0 s_int16 n);
#endif/*USE_BUTTON*/

#else/*1*/

#if defined(USE_BUTTON)
s_int16 ApplAddr(register __i0 s_int16 **d, register __a1 s_int16 mode,
		 register __a0 s_int16 n) {
    /*Don't check mode, all we get is APPL_AUDIO.*/
	//if (mode == APPL_AUDIO)
	{
		register u_int16 t = hwSampleRate/16;
		/* generate a timebase for User Interface */
		ui.Cnt += n;
		if (ui.Cnt > t) {
			ui.Cnt -= t;
			ui.Timer++;
			ui.Strobe = 1;
		}
	}
}
#endif/*USE_BUTTON*/
#endif


#ifdef UART_FIFO
u_int16 uiNum = 0;
s_int16 uiLoops = -1;
#endif/*UART_FIFO*/

s_int16 record = 0;

/*
  Called before HALT
 */
void UserHook(void) {
//USEX(UART_DATA) = spiState;

	#if	defined(UART_FIFO)
	if (UartFill()) {
		register int cmd = UartGetByte();
		if (cmd == 0xef) { /* Jump to monitor */
			Disable();
			Monitor();
		} else if (cmd == 'E') { /* End Record */
			record = 0;
		} else if (cmd == 'V') { /* Set direct volume */
			USEX(SCI_VOL) = (uiNum & 255) * 0x0101;
			uiNum = 0;
			goto showvol;
		} else if (cmd == '\n' || cmd == '\r') {
			uiNum = 0;
		} else if (cmd >= '0' && cmd <= '9') {
			uiNum = uiNum*10 + cmd - '0';
		} else if (cmd == 'C') { /* cancel play: replay the same file */
			record = -1;
			USEX(SCI_MODE) |= (1<<SCIMB_OUT_OF_WAV);
		} else if (cmd == '+') {
			if (USEX(SCI_VOL)) {
				USEX(SCI_VOL) -= 0x0101; //KeyEventHandler(ke_volumeUp2);
			}
			goto showvol;//putword(player.volume);
		} else if (cmd == '-') {
			USEX(SCI_VOL) += 0x0101;
			showvol:
			SetVolumeFromSpi();
			common.volume = USEX(SCI_VOL);
			putch(common.volume);
		} else if (cmd == '?') {
			/* position + other info -- Note: will block. */
		        //putword(USEX(SCI_DECODE_TIME));
			putword(spiPage - fileStart * 2);
			//putch((fileSize-2*spiSize) / ((fileSize >> 8)+1));
		} else {
			/*unknown command*/
			echo:
			putch(cmd);
		}
	}
	#endif/*UART_FIFO*/
}
	
	
#if 1
#include "imalib.h"
#include "spi.h"
extern u_int16 streamBuffer[512]; /* for ADC */
extern __mem_y audioBuffer[2048]; /* continues to reverbDelays etc.. 0..0x17ff */

volatile s_int16 *adcWrPointer = streamBuffer;
s_int16 *adcRdPointer = streamBuffer;
#define IMABUFFERSIZE (48*128) //6144, size must be multiples of 128 words
__mem_y u_int16 *imaWrPointer = audioBuffer;
volatile __mem_y u_int16 *imaRdPointer = audioBuffer;
s_int16 imaPhase = 0;

struct MyIma {
  s_int16 val;
  s_int16 state;
  s_int16 step;
  s_int16 c;
  s_int16 phase;
} myIma;

/* VS1103B / hardware.c */
auto void RealSetRate(register __c1 u_int16 rate);
/* VS1103B / ima.c */
auto void ImaCompand(register s_int16 *d, s_int16 n);
/* VS1103B / ima.c */
extern u_int16 __y constMultip, maxMultip;

auto s_int16 ImaBufFill(void) {
	s_int16 t = (imaWrPointer - imaRdPointer);
	if (t < 0) t += IMABUFFERSIZE;
	return t;
}

auto void ToImaBuf(register __d1 u_int16 d) {
	*imaWrPointer++ = d;
	if (imaWrPointer >= &audioBuffer[IMABUFFERSIZE]) {
		imaWrPointer = audioBuffer;
	}
}



static u_int16 eepromPageNo = SPI_PAGES_PER_BLOCK;
extern u_int16 __mem_y multip;

#if 0
struct ImaDelayLine {
  s_int16 val;
  s_int16 minStep;
};
#endif

extern struct ImaDelayLine __mem_y dl[IMA_DELAY_LINE_LEN];
extern struct ImaDelayLine __mem_y *dlp;
#endif



extern u_int16 extClock4KHz, intClock2KHz, clockX, clockA, clockMaxA, oldClock4KHz;
auto void MyMain(register s_int16 __a1 fullReset) {
	#if defined(SCI_UI) && defined(ENABLE_WATCHDOG)
	USEX(WDOG_CONFIG) = 1000;
	USEX(WDOG_RESET) = WDOG_RESET_VAL;
	#endif
	
	USEX(SCI_STATUS) &= ~((1<<SCIST_APDOWN1)|(1<<SCIST_APDOWN2));
	
	//USEX(SCI_CLOCKF) = 0x0000; /*1.0x 122888000Hz */
	//    USEX(SCI_CLOCKF) = 0x4000; /*2.0x 122888000Hz */
	//SetClockFromSpi();
	//USEX(UART_DIV) = UartDiv(intClock2KHz, uartByteSpeed);
	/*
	Some exact frequencies:
	8000, 9600, 12000, 12800, 16000, 24000, 25600, 32000, 38400, 48000
	*/
	#define FREQUENCY 8000 //12000
	//#define FREQUENCY 12000
	//#define FREQUENCY 48000
	//#define FREQUENCY 32000
	/*
	You can also set the frequency by selecting the divider.
	*/
        //#define DIV 19  //20210.5Hz
	
	#ifdef FREQUENCY
	USEX(MODU_DIV) = 4*12288000L/128/FREQUENCY; /*12kHz*/
	#else
	#if DIV
	USEX(MODU_DIV) = DIV;
	#define FREQUENCY  (4*12288000L/128/DIV) /* exact only for some dividers */
	#else
	err 'neither FREQUENCY nor DIV set!';
	#endif
	#endif
	dlp = dl;
	
	
	#ifdef UART_FIFO
	//UartInit();
	#endif
	
	#if defined(USE_BUTTON)
	applAddr = ApplAddr;
	#else
	applAddr = NULL;
	#endif/*USE_BUTTON*/
	
	//putstrp("\precmodule2 here...\n");
	USEX(INT_ENABLE) = 0;
	Enable();
	
	/* determine number of playable files */
	{
		fileStart = FindEntry(&fileEntry, &dirBlock);
		#if 0 //defined(UART_FIFO)
		putstrp("\pfileStart");
		putword(fileStart>>16);
		putword(fileStart);
		putch(' ');
		putword(fileEntry);
		putch('\n');
		#endif
	}
	again:
	stream_rd_pointer = stream_wr_pointer = stream_buffer;
	stream_rd_odd = 0;
	
	
	USEX(INT_ENABLE) = (1<<INT_EN_RX);
	memset(&myIma, 0, sizeof(myIma));
	imaWrPointer = imaRdPointer = audioBuffer;
	imaPhase = 0;
	constMultip = 0;		/* linear: 1024 = 1, 0 = autogain       */
	multip = 65535;		/* linear: 1024 = 1, initial multiplier */
	maxMultip  = 65535;		/* linear: 1024 = 1                     */
	/* Stop DAC - use its buffer. */
	USEX(INT_ENABLE) = (1<<INT_EN_MODU) | (1<<INT_EN_RX);
	USEX(DAC_LEFT) = USEX(DAC_RIGHT) = 0;
	
	
	spiPage = fileStart * 2;
	#if 1
	/* Init WAV header */
	{
		static __mem_y const u_int16 wavHeader[] = {
			0x5249, 0x4646, 0xffff, 0xffff,   //"RIFF", size
			0x5741, 0x5645, 0x666d, 0x7420, 0x1400, 0x0000, //"WAVEfmt ", size
			0x1100, //formatTag
			0x0100, //channels
			SWAP(FREQUENCY), //samplesPerSec lo
			0x0000, //samplesPerSec hi
			0xd70f, //avgBytesPerSec lo
			0x0000, //avgBytesPerSec hi
			0x0001, //block align (in bytes)
			0x0400, //bits per sample
			0x0200, //extra size
			0xf901, //samples per block
			0x6661, 0x6374, 0x0400, 0x0000, 0xffff, 0x3f00, //"fact", size, numSamp
			0x6461, 0x7461, 0xffff, 0xffff //"data", size
		};
		//u_int16 bps = 4;//encoderBitsPerSample[adcControl.encMode];
		memcpyYY(imaWrPointer, wavHeader, sizeof(wavHeader));
		//imaWrPointer[12] = Swap16(FREQUENCY); //samplesPerSec low
		//imaWrPointer[13] = Swap16(rate>>16); //samplesPerSec hi
		//imaWrPointer[17] = Swap16(bps); //bits per sample
		if (0) {
			register u_int32 bytps = (u_int32)(1 * 256) * FREQUENCY / 505;
			imaWrPointer[14] = Swap16(bytps); //avgBytesPerSec low
			imaWrPointer[15] = Swap16(bytps>>16); //avgBytesPerSec hi
			//imaWrPointer[16] = 0x0001;//Swap16(256*channels); //blockAlign = 256 bytes per ch
			//imaWrPointer[19] = 0xf901; //samples per block 505
		}
		imaWrPointer += sizeof(wavHeader);
	}
	#endif
	
#if 0	
	putstrp("\pspiPage/blocks ");
	putword(spiPage>>16);
	putword(spiPage);
	putword(common.blocks>>16);
	putword(common.blocks);
	putch('\n');
#endif
	if (spiPage/2 < common.blocks) {  /* Memory full? */
		record = 2;
		USEX(SCI_AICTRL0) = 0;
		#if defined(UART_UI) || defined(UART_FIFO)
		putstrp((USEX(SCI_MODE) & (1<<SCIMB_LINE))?
			"\precord line\n" : "\precord mic\n");
		while (record > 0) {
			static s_int16 sample = 0;
			static u_int16 tp = 0;
			if (adcRdPointer != adcWrPointer) {
				sample = *adcRdPointer;
				if (++adcRdPointer >= &streamBuffer[512]) {
					adcRdPointer = &streamBuffer[0];
				}
				#if 1
				ImaCompand(&sample, 1);
				if (!myIma.phase) {
					myIma.val = sample;
					ToImaBuf((myIma.val<<8) | ((u_int16)myIma.val>>8));
					ToImaBuf(myIma.state<<8);
				} else {
					myIma.step = imaStepSizeTable[myIma.state];
					myIma.c = ImaDiv(sample, myIma.val, myIma.step);
					{
						register s_int16 t = (myIma.phase+1)&3;
						tp |= myIma.c << t*4;  /* insert 4 bits */
						if (t==1) {
							ToImaBuf(tp);
							tp = 0;
						}
					}
					myIma.val = ImaUpdateState(myIma.val, myIma.step, &myIma.state,
					myIma.c);
				}
				#endif
				if (++myIma.phase >= ENCODE_SAMPLES) {
					/* Reset encoding */
					myIma.phase = 0;
					//putch('.');
				}
	
			} else {
				static int erased = 0; /* We know it is erased already... */
	
				if (erased == 0 && (spiPage & 15) == 0) {
					if ((SpiGetStatus() & 1) == 0) {
						SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
						SingleCycleCommand(SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS);
						EeUnprotect();
						USEX(GPIO_ODATA) &= ~SPI_xCS;
						SpiSendReceiveSpi(SPI_EEPROM_COMMAND_ERASE_4K_SECTOR<<8,8);
						SpiSendReceiveSpi(spiPage,16);
						SpiSendReceiveSpi(0,8);
						USEX(GPIO_ODATA) |= SPI_xCS;
						erased = 1;
					}
					//putch('e');
				} else {
	
					/* ready for more */
					if (ImaBufFill() > 256/2) { /* 256-byte program pages */
	
						if ((SpiGetStatus() & 1) == 0) {
							EeUnprotect();
							USEX(GPIO_ODATA) &= ~SPI_xCS;
							SpiSendReceiveSpi(SPI_EEPROM_COMMAND_WRITE<<8,8);
							SpiSendReceiveSpi(spiPage,16);
							SpiSendReceiveSpi(0,8);
							{
								u_int16 n;
								for (n=0; n<128; n++){
									SpiSendReceiveSpi(*imaRdPointer++,16);
								}
							}
							USEX(GPIO_ODATA) |= SPI_xCS;
	
							//putch('+');
							if (imaRdPointer >= &audioBuffer[IMABUFFERSIZE]) {
								imaRdPointer -= IMABUFFERSIZE;
							}
							spiPage++;
							erased = 0; /* next block is not erased yet. */
							if (spiPage/2 >= common.blocks) {
								/* End of memory */
								record = 0;
							}
						}
					}
					UserHook();
				}
			}
		}
		SpiWaitStatus();
		if (record == 0) {
		  putstrp("\pend record\n");
			MakeEntry((spiPage - fileStart * 2)*256, fileEntry, dirBlock);
		} else {
		  putstrp("\pcancel record\n");
			/* Cancelled */
		}
		#endif
	}
	//putstrp("\pReturn to player...\n");
	Disable();
	USEX(MODU_DIV) = 0;
	USEX(INT_ENABLE) = (1<<INT_EN_RX);
	{	/* Restore DAC and MODU interrupt vectors. */
		register u_int32 d;
		//d = ReadFromProgramRam(0x40a0);
		//WriteToProgramRam(0x20, d>>16, d);
		d = ReadFromProgramRam(0x40a3);
		WriteToProgramRam(0x23, d>>16, d);
	}
	//SpiLoad2(0+3, 1);
	memsetY(audioBuffer, 0, 2048);
	SpiLoad2(MODPLAYER_ADDR+3, 1);
	//SpiLoad2(3, 1);
}
