#define STANDALONE
#define USE_EARSPEAKER
#include <string.h>
#include <dsplib.h>
#include "module.h"
#include <parametric.h>
#include <general.h>

auto void PatchInitHardware(void);

void putch(register __a0 int ch);
void putch15(register __a0 int ch);
void putword(register __a0 int ch);
void Monitor(void); /*never returns*/
auto void play_frame(void);

//void Disable();
//void Enable();
//void Reset();

//#undef putchar
//#undef puts

//#include <stdio.h>

#include <stdlib.h>

#ifndef GPIO_IDATA
#define GPIO_IDATA GPIO_DATA
#endif

#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   8 /*MMC clk*/
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */

extern __y u_int16 hwSampleRate;




u_int16 ClockSdi(void); /* dummy return value */


extern s_int16 rtmidi_int_vecs; /* Actually in code memory! */
extern s_int32 __y moduOffset;

auto void MyMain(register s_int16 __a1 fullReset) {
  USEX(SCI_VOL) = 0x0000; //0dB
  //USEX(SCI_VOL) = 0x0c0c; //-6dB
    //USEX(SCI_VOL) = 0x1010; //-8dB
    //USEX(SCI_VOL) = 0x1818; //-12dB

    USEX(SCI_MODE) &= ~(1<<SCIMB_OUT_OF_WAV);
    USEX(SCI_MODE) |= (1<<SCIMB_SDI_NEWMODE);
    USEX(GPIO_DDR)   = SPI_xCS|SPI_CLK|SPI_xCS2;
    USEX(GPIO_ODATA) = SPI_xCS|SPI_xCS2;

    USEX(SCI_CLOCKF) = 0x9800; //3.0x
    //    PatchInitHardware(); /* does not clear user area */

    uartByteSpeed = 115200/10;
    //uartByteSpeed = 9600/10;
    SetClockFromSpi();

    InitCommon();

    //AudioInit(); //rather use..
    //AudioSet(2, 44100U);

    /* Allow DREQ and enable interrupts, VERY IMPORTANT! */
    USEX(INT_ENABLE) = 0;
//    USEX(INT_GLOB_ENA) = 0;
    USEX(INT_GLOB_ENA) = 0;
//    USEX(INT_GLOB_ENA) = 0;

    AudioSet(2, 44100U); //Same as vs1000 module
    //AudioSet(2, 48000U);
    InitReadFrame();

    USEX(INT_ENABLE) = (INT_EN_ALL) & ~(1<<INT_EN_RX);
    USEX(SER_DREQ) = 1;
    /*otherwise keep it in powerdown until MMC found*/
    USEX(SCI_STATUS) &= ~(1<<SCIST_APDOWN1); /* enable ANALOG power */

    skipMixer = 1;
    USEX(GPIO_DDR) |= (1<<3)|(1<<2)|(1<<1);
#define WITH_ADC
#ifdef WITH_ADC
    USEX(MODU_DIV) = 24; //3*12.288M/128/24 = 12kHz
    USEX(SCI_MODE) |= (1<<SCIMB_LINE);
#endif
    
    {
      register u_int16 phl = 0, addl = 1486 & ~7;
      static s_int16 buf[2*16];
      register s_int16 *p = buf;
      while (1) {
	*p++ = frsine32((u_int32)phl<<16)>>16;
	*p++ = frsine32(0x80000000+((u_int32)phl<<16))>>16;
	phl += addl;
	if (p >= &buf[2*16]) {
	  p = buf;
	  WmaStereoCopy(buf, 16);
#ifdef WITH_ADC
	  //44100/16 = 2756.25 Hz
	  {
	    static s_int16 low = 32767, high = -32768, rep = 0;
	    s_int16 d = USEX(MODU_DATA);
	    if (low > d)  low = d;
	    if (high < d) high = d;
	    if (rep++ > 2756/2) {
	      s_int32 pp = (s_int32)high - low;
	      rep = 0;
	      if (pp > 32767) pp = 32767;
	      USEX(SCI_AICTRL0) = pp; //if someone wants to read them
	      USEX(SCI_AICTRL1) = high;
	      USEX(SCI_AICTRL2) = low;
	      putch((s_int16)pp>>8);
	      low = 32767;
	      high = -32768;
	    }
	  }
#endif
	}
	if (USEX(UART_STATUS) & UART_ST_RXFULL) {
	  u_int16 ch = USEX(UART_DATA);
	  addl = (ch * 128);// & ~7;
	  putch(ch);
	}
      }
    }
}
