#include <stdio.h>
#define STANDALONE
#define USE_EARSPEAKER
#include <string.h>
#include "module.h"
#include <parametric.h>
#include <general.h>
#ifdef UART_FIFO
#include "uartctrl.h"
#endif

extern s_int16 pcm_point;
extern s_int16 __y const cos64NewTab[128];

#define FILENAME "\pSDMODULESPI"

auto void PatchInitHardware(void);

//void SetSourcesFromSpi(void);
//auto void SetDreqSafetyAreaFromSpi(void);

void putch(register __a0 int ch);
void putch15(register __a0 int ch);
void putword(register __a0 int ch);
void Monitor(void); /*never returns*/

#if 1
static char hex[] = "0123456789ABCDEF";
void puthex(u_int16 d) {
  register i;
  for (i=0;i<4;i++) {
    putch(hex[((d>>12)&15)]);
    d <<= 4;
  }
}
#endif

void putstrp(register __i2 const u_int16 *s) {
  while (1) {
    if (!(*s & 0xff00))
      break;
    putch(*s>>8);
    if (!(*s & 0xff))
      break;
    putch(*s++); //putch(*s++);
  }
}

auto void play_frame(void);
//void Disable();
//void Enable();
//void Reset();

//#undef putchar
//#undef puts

//#include <stdio.h>

#include <stdlib.h>

#ifdef WAIT_FOR_UART_BYTE
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC))
#else
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#endif/*elseWAIT_FOR_UART_BYTE*/


#ifndef GPIO_IDATA
#define GPIO_IDATA GPIO_DATA
#endif

#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   2
//#define SPI_CLK   8 /*MMC clk*/
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
//#define SPI_xCS2  2
#define SPI_xCS2  8
#define SPI_MOSI  1 /* DREQ */

//#define SPI_WREN  0x06
//#define SPI_WRDI  0x04
//#define SPI_RDSR  0x05
//#define SPI_WRSR  0x01
#define SPI_READ  0x03
//#define SPI_WRITE 0x02


auto void busywait(void) {
  int i;
  for (i=0;i<10;i++) {
    USEX(SER_DREQ);
  }
}
auto void SpiPrivDelay(void) {
  int i;
  for (i=0;i<10;i++) {
    USEX(SER_DREQ);
  }
}
auto u_int16 SpiPrivSendReceive(register __a0 u_int16 dat,
				register __a1 s_int16 bits) {
  register u_int16 odata = 0;
  while (bits--) {
    USEX(SER_DREQ) = (dat>>bits);
    SpiPrivDelay();
    USEX(GPIO_ODATA) |= SPI_CLK;
    SpiPrivDelay();
    odata <<= 1;
#if SPI_MISO == 4
    odata |= (USEX(GPIO_IDATA) >> 2) & 1;
#else
    odata |= (USEX(GPIO_IDATA) & SPI_MISO) ? 1 : 0;
#endif
    USEX(GPIO_ODATA) &= ~SPI_CLK;
  }
  return odata;
}


#define SPI_EEPROM_COMMAND_WRITE_ENABLE  0x06
#define SPI_EEPROM_COMMAND_WRITE_DISABLE  0x04
#define SPI_EEPROM_COMMAND_READ_STATUS_REGISTER  0x05
#define SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER  0x01
#define SPI_EEPROM_COMMAND_READ  0x03
#define SPI_EEPROM_COMMAND_WRITE 0x02
#define SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS 0x30
#define SPI_EEPROM_COMMAND_ERASE_4K_SECTOR 0x20
#define SPI_EEPROM_COMMAND_ERASE_CHIP 0xC7

s_int16 SpiGetStatus(void) {
  __mem_y s_int16 t;
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi((SPI_EEPROM_COMMAND_READ_STATUS_REGISTER<<8), 8);
  t = SpiSendReceiveSpi(0, 8);
  USEX(GPIO_ODATA) |= SPI_xCS;
  return t;
}
void SingleCycleCommand(u_int16 cmd){
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi((cmd<<8),8);
  USEX(GPIO_ODATA) |= SPI_xCS;
}
u_int16 SpiWaitStatus(void) {
  u_int16 status;
  while ((status = SpiGetStatus()) & 1)
    ;
  return status;
}

void EeUnprotect(){
  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi(SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER<<8,8);
  SpiSendReceiveSpi(0x02<<8,8); //Sector Protections Off
  USEX(GPIO_ODATA) |= SPI_xCS;
  SpiWaitStatus();
  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
}
#if 0
void Erase4kBlock(u_int16 blockn) {
    // Erase 4K sector
    SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
    SingleCycleCommand(SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS);
    EeUnprotect();
    USEX(GPIO_ODATA) &= ~SPI_xCS;
    //SPI_MASTER_8BIT_CSLO;
    SpiPrivSendReceive(SPI_EEPROM_COMMAND_ERASE_4K_SECTOR,8);
    SpiPrivSendReceive(blockn>>7,8);            // Address[23:16] = blockn[14:7]
    SpiPrivSendReceive((blockn<<1)&0xff,8);     // Address[15:8]  = blockn[6:0]0
    SpiPrivSendReceive(0,8);                    // Address[7:0]   = 00000000
    USEX(GPIO_ODATA) |= SPI_xCS;
    //SPI_MASTER_8BIT_CSHI;
    SpiWaitStatus();
}
u_int16 SpiWriteBlock(u_int16 blockn, u_int16 *dptr) {
  
  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
  SingleCycleCommand(SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS);
  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);

  USEX(GPIO_ODATA) &= ~SPI_xCS;
  //SPI_MASTER_8BIT_CSLO;
  SpiPrivSendReceive(SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER, 8);
  SpiPrivSendReceive(0x02, 8); //Sector Protections Off
  //SPI_MASTER_8BIT_CSHI;
  USEX(GPIO_ODATA) |= SPI_xCS;

  SpiWaitStatus();
  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  //SPI_MASTER_8BIT_CSLO;
  SpiPrivSendReceive(SPI_EEPROM_COMMAND_WRITE, 8);
  SpiPrivSendReceive((blockn>>7),8);            // Address[23:16] = blockn[14:7]
  SpiPrivSendReceive((blockn<<1)&0xff,8);     // Address[15:8]  = blockn[6:0]0
  SpiPrivSendReceive(0,8);                    // Address[7:0]   = 00000000
 
  //SPI_MASTER_16BIT_CSLO;
  {
    u_int16 n;
    for (n=0; n<128; n++){
      SpiPrivSendReceive(*dptr++,16);
    }
  }
  //SPI_MASTER_8BIT_CSHI;
  USEX(GPIO_ODATA) |= SPI_xCS;

  SpiWaitStatus();

  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  //SPI_MASTER_8BIT_CSLO;
  SpiPrivSendReceive(SPI_EEPROM_COMMAND_WRITE,8);
  SpiPrivSendReceive(blockn>>7,8);       
  SpiPrivSendReceive(((blockn<<1)+1)&0xff,8); // Address[15:8]  = blockn[6:0]1
  SpiPrivSendReceive(0,8);              
  
  //SPI_MASTER_16BIT_CSLO;
  {
    int n;
    for (n=128; n<256; n++){
      SpiPrivSendReceive(*dptr++,16);
    }
  }
  USEX(GPIO_ODATA) |= SPI_xCS;
  //SPI_MASTER_8BIT_CSHI;
  SpiWaitStatus();
  return 0;
}
u_int16 SpiVerifyBlock(u_int16 blockn, u_int16 *dptr) {
  SpiWaitStatus();
  
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  //SPI_MASTER_8BIT_CSLO;
  SpiPrivSendReceive(SPI_EEPROM_COMMAND_READ,8);
  SpiPrivSendReceive(blockn>>7,8);            // Address[23:16] = blockn[14:7]
  SpiPrivSendReceive((blockn<<1)&0xff,8);     // Address[15:8]  = blockn[6:0]0
  SpiPrivSendReceive(0x00,8);                    // Address[7:0]   = 00000000
  //SPI_MASTER_16BIT_CSLO;
  {
    int n;
    for (n=0; n<256; n++){
	u_int16 t = SpiPrivSendReceive(0,16);
	if (*dptr++ != t) {
	    puthex(n);
	    puthex(dptr[-1]);
	    puthex(t);
	    puts("=!");
	//SPI_MASTER_8BIT_CSHI;	
	USEX(GPIO_ODATA) |= SPI_xCS;
	return 1;
      }
    }
  }
  USEX(GPIO_ODATA) |= SPI_xCS;
  //SPI_MASTER_8BIT_CSHI;
  return 0;
}
#endif


void main(void) {
  FILE *fp = NULL;
  /* Test / program */

  USEX(SCI_AICTRL1) = 0;
  USEX(SCI_AICTRL0) = 0xa000; /*Started*/

  uartByteSpeed = 115200/10;
  USEX(INT_ENABLE) = (1<<INT_EN_DAC)|(1<<INT_EN_RX);
  /* Sine test */
  {
    register __i1 s_int16 *wr;
    register s_int16 i, phase = 0;
    s_int16 loops = 24000U/16; /* max 1 second */
    loops = 512; //32; enough to fill the audio buffer once over
    USEX(SCI_STATUS) &= ~(1<<SCIST_APDOWN1);
    USEX(SCI_STATUS) &= ~(1<<SCIST_APDOWN2);
    AudioSet(2, 48000U);
    //ai.channels = 2;
    skipMixer = 1;
    
    while (1) {
      pcm_point = 0;
      wr = pcm_sample;
      for (i=0; i<32; i++) {
	*wr++ = cos64NewTab[phase];
	*wr++ = cos64NewTab[(phase+64)&127];
	phase = (phase + 3) & 127; /* 1125Hz */
      }
      wav_write();
      
      //puthex(loops);
      //putch('\n');
      if (--loops <= 0 || USEX(SCI_AICTRL1) != 0) {
	break; /* Done */
      }
    }
  }
  //   USEX(INT_ENABLE) = (1<<INT_EN_RX);

  //USEX(UART_DIV) = UartDiv();

  /*
    GPIO0 100k to IOVDD (100k to GPIO2)
    GPIO1 100k to GND (SPI CLK, SD XCS)
    GPIO2 100k to GND (100k to GPIO0)
    GPIO3 100k to GND (SD CLK)
  */
 again:
  
  /* without uSD card */
  while (1) {
    u_int16 failed = 0;

    USEX(GPIO_DDR)   = 15; /*outputs*/
    USEX(GPIO_ODATA) = 15; /*drive high*/
    busywait();
    failed |= 0xf ^ USEX(GPIO_IDATA);
    USEX(GPIO_DDR) = 0; /*inputs*/
    //failed |= 0xe ^ USEX(GPIO_IDATA);
    busywait();

    failed |= USEX(GPIO_IDATA); /*0*/

    USEX(GPIO_DDR)   = 3; /*outputs*/
    USEX(GPIO_ODATA) = 3; /*drive high*/
    busywait();
    failed |= 7 ^ USEX(GPIO_IDATA); /*7*/
    USEX(GPIO_ODATA) = 0; /*drive low*/
    //failed |= 4 ^ USEX(GPIO_IDATA); /*4*/
    busywait();

    failed |= USEX(GPIO_IDATA); /*0*/
    //puthex(failed);
    if (failed) {
      /*Note: do not flag error! This is produced if uSD is inserted.*/
      putstrp("\p\n**Pull-Up test failed!\n");
    } else {
      putstrp("\p\nPull-Ups ok!\n");
      break;
    }
  }

  while (1) {
    putstrp("\ptesting SPI FLASH\n");
    USEX(MODU_DIV) = 0;
    USEX(GPIO_DDR)   = SPI_xCS|SPI_CLK|SPI_xCS2;
    USEX(GPIO_ODATA) = SPI_xCS|SPI_CLK|SPI_xCS2;

    /* 'wake up' spi memory */
    SpiSendReceiveSpi(0, 8);
    {
      register u_int16 status;
      USEX(GPIO_ODATA) |= SPI_xCS;
      for (status=0;status<450;status++) {
	//BusyWait10();
	SpiPrivSendReceive(0,16);
      }

      USEX(GPIO_ODATA) &= ~SPI_xCS;

      /* Use RDID instead, more manufacturers use it like this. */
      {
	u_int16 manuf;
	SpiPrivSendReceive(0x9f,8); /*0x9f=RDID*/
	manuf = SpiPrivSendReceive(0x00,8);
	status = SpiPrivSendReceive(0x00,16);
	USEX(GPIO_ODATA) |= SPI_xCS;
	
	//putword(status);
	//putch('\n');
	puthex(manuf);
	puthex(status);
	if (status != 0xffff && status != 0) {
	  /*
	    C2=Macronix
	    C8=Spansion
	    EF=Winbond
	    manufacturer, memory type, size
	    00c22015 = Macronix SPI FLASH, 2MB
	    00c84015 = Spansion SPI FLASH, 2MB
	  */
	  if (manuf != 0x00c2 && manuf != 0x00ef) {
	    putstrp("\p **ERROR: not Macronix or Winbond!\n");
	    if (manuf == 0x00c8) {
	      putstrp("\p(Spansion)\n");
	    }
	  } else if ((status & 255) == 0x15) {
	    putstrp("\p 2MB SPI memory found!\n");
	  } else if ((status & 255) == 0x18) {
	    putstrp("\p 16MB SPI memory found!\n");
	  } else {
	    putstrp("\p **ERROR: Unknown size SPI memory found!\n");
	  }
	  break;
	} else {
	  putstrp("\p **ERROR: No SPI memory found!\n");
	}
      }
    }
  }


#if 1
  USEX(SCI_AICTRL0) = 0x1234;
  while (1) {
    if (USEX(SCI_AICTRL0) == 0xabac) {
      putstrp("\pSCI seems to work, test finished.\n");
      break;
    }
  }
#endif

#if 0
  putstrp("\pOpening VSMD321C001/sdprogram.spi for reading\n");
  USEX(INT_ENABLE) = 0;//(1<<INT_EN_RX);
  //USEX(INT_GLOB_DIS) = 0;
  fp = fopen("VSMD321C001/sdprogram.spi", "rb");
  if (!fp) {
    putstrp("\pCould not open VSMD321C001/sdprogram.spi!\n");
    goto exit;
  } else {
    u_int16 blk = 0, len;
#define BUF_SIZE (512/2)
    static u_int16 buf[BUF_SIZE];
    putstrp("\pProgramming VSMD321C001/sdprogram.spi\n");
    while (len = fread(buf, 1, BUF_SIZE, fp)) {
      if ((blk & 7)==0) {
	puthex(blk);
	putstrp("\p Erase\n");
	Erase4kBlock(blk);
      }
      SpiWriteBlock(blk, buf);
      if (SpiVerifyBlock(blk, buf)) {
	putstrp("\p Error\n");
      }
      memset(buf, -1, sizeof(buf));
      blk++;
    }
    fclose(fp);
  }
 exit:
  putstrp("\pDone!\n");
  USEX(INT_ENABLE) = (1<<INT_EN_RX);
  while (1)
    ;
#endif
  putstrp("\pDone!\n");
  {
    int i;
    for (i=0;i<61;i++)
      putch(0x01);
    while ((USEX(UART_STATUS) & UART_ST_TXRUNNING))
      ;
  }
  //((void (*)(void))(0x4000))();
  while (1)
    ;
}
